!
! Fil ov127.mod
!
! 
!
!       gir modellen et navn
!
MODEL OV127
!
!
!
!       
!
!
TABLES
!
	DIMM(3)         ! dimension or max # indeks
	SKAL(2)		! Skalardata
!                         
!
DISKDATA 
!
	DIMM = ov127.dim
	SKAL = ov127.ska
!
!
LET TMAX = DIMM(1) 	! max # aar
LET IMAX = DIMM(2) 	! max # miner (=4 i denne oppgaven)
LET MMAX = DIMM(3) 	! max # miner (=3        ""       )
!
LET DISK = SKAL(1)	! diskonteringsrate (=10%   ""    )
LET INCO = SKAL(2)	! salgspris (10  pund   ""       ) 
!
TABLES
!
MOUT(IMAX) 		! max output fra gruve i 
!
QUAL(IMAX)		! kvalitet paa aare fra gruve i
!
PQREQ(TMAX)		! Kvalitet krevet i aar t
!
ROY(IMAX)		! betalt royalitet for aa holde gruve i aapen 
!
!beregnes under assign
!
RDIS(IMAX,TMAX)		! Royalitet ROY diskontert med diskonteringsfaktor DISK
!
IDISC(TMAX)		! Inntekt INCO diskontert med diskonteringsfaktor DISK
!
!
! Leser tabell fra fil
!
DISKDATA
!
	MOUT(1)	= ov127.mou
!
	QUAL(1)	= ov127.qua
!
	PQREQ(1)= ov127.pqr
!
	ROY(1)	= ov127.roy
!
!
ASSIGN
!
RDIS(i=1:IMAX, t=1:TMAX) = disc(DISK, t)*ROY(i) 	! diskontert royalities
!
IDISC(t=1:TMAX)	= disc(DISK, t)*INCO			! diskontert inntekt
!
!
!
!
!
VARIABLES
!
!
!
work(i=1:IMAX, t=1:TMAX)	! =1 hvis gruve i arbeides i aar t, 0 ellers
!
open(i=1:IMAX, t=1:TMAX)	! =1 hvis gruve i aapen i aar t, 0 ellers
!
out(i=1:IMAX, t=1:TMAX)		! Hvor mye som produseres i aar t fra gruve i
!
quan(t=1:TMAX)			! produsert blandet aare pr. aar
!
!
!
!
!
CONSTRAINTS
!
! Total profitt er inntektene(diskontert) fra aa selge blandete aarematerialet
! minus de diskonterte royalitetene fra de aapne gruvene
MAXOBJ:							&
	- SUM(i=1:IMAX, t=1:TMAX) RDIS(i,t)*open(i,t) 	&
        + SUM(t=1:TMAX) IDISC(t)*quan(t)		$
!
!
!
! Hvis det ikke arbeides i gruve(i) i aar t , 
! kan det ikke prod noe dette aaret 
!
MAXO(i=1:IMAX, t=1:TMAX):				&
	out(i,t) - MOUT(i)*work(i,t) < 0
!
!
!Hvor mange gruver kan vaere aapne samtidig 
!
MAWORK(t=1:TMAX):					&
	SUM(i=1:IMAX) work(i,t) < MMAX
!
!
! Er gruven LUkket, kan man heller ikke ARbeide i den
!
LUAR(i=1:IMAX, t=1:TMAX):				&
	work(i,t) - open(i,t) < 0
!
!
! Stenges gruven, tvinger denne restriksjonen gruven aa forbli 
! stengt permanent 
!
TID(i=1:IMAX, t=1:(TMAX-1)):				&
	open(i,t+1)-open(i,t) < 0
!
!
! Hver mines kvalitet blandet ut skal vaere lik
! etterspurt blandeforhold
!
KVAL(t=1:TMAX):						&
	SUM(i=1:IMAX) QUAL(i)*out(i,t) 			&
	- PQREQ(t)*quan(t) = 0
!
!
! Ant tonn produsert i gruve pr aar er lik quan
!
LIKV(t=1:TMAX):						&
	SUM(i=1:IMAX)out(i,t)-quan(t) = 0
!
!
!
!
!
BOUNDS
!
!Om det skal arbeides eller ei i gruven er en binaervar
!
 work(i=1:IMAX, t=1:TMAX) .BV.
!
!
!
!Om gruven skalapnes eller ei, er en binaervar
!
 open(i=1:IMAX, t=1:TMAX) .BV.
!
!
GENERATE
!
! Problemet loese ved foielgende kall
! mp-model ov127
! >INPUT
! mp-opt ov127
! >INPUT
! >MAXIMIZE 	finner kont.loesning
! >GLOBAL  	finner heltallsloesning vha Branch & Bound algoritmen
! >FPRINT	Skriver ut loesningsfilen ov127.prt
! >PRINT 	Skriver loesningen ut paa skjermen
! >QUIT
!
! Rapport
! kalles etter at mp-opt har maksimert
! mp-model ov127
! >RESTORE
! >INPUT
! >QUIT
!
!
! Beregner profitten for aa skrive den ut med print
!
ASSIGN

profitt = - SUM(i=1:IMAX, t=1:TMAX) RDIS(i,t)*open(i,t) + SUM(t=1:TMAX) IDISC(t)*quan(t)
!
!
PRINT 
!
!   Gruve stenges hvis = 0, (tid oeker mot hoyre ->, og gruver nedover)
!
open
!
!   Hver gruve skal produsere foelgende i mill tonn (gruve nr. ned, aar ->)
!
out
!
!   Maximum profitt blir da (millioner pund )
!
profitt
!
!
! Denne produksjonen medforer derfor at det hvert aar blir produsert
! foelgende mengder med riktig blandet mengde gruvemateriell(i millioner tonn)
!
quan
!
!
!





